'use strict';

var path = require('path');

module.exports = function webpackExtra (config, appPath) {
  var appPackage = require(path.join(appPath, 'package.json'));
  var appHasOwnProperty = function (key) {
    return Object.hasOwnProperty.bind(appPackage, key)();
  }

  if (appHasOwnProperty('extraBabelPlugins')) {
   config.module.loaders = config.module.loaders.map(function (loader) {
      if (loader.loader === 'babel') {
        loader.query.plugins = (loader.query.plugins || [])
          .concat(appPackage.extraBabelPlugins);
      }

      return loader;
    })
  }

  config.module.loaders = config.module.loaders.map(function (loader) {
    if (loader.loader === 'babel' && appHasOwnProperty('extraBabelPlugins')) {
      loader.query.plugins = (loader.query.plugins || []).concat(appPackage.extraBabelPlugins);
    }

    if (loader.loader.indexOf('less') !== -1 && appHasOwnProperty('theme')) {
      loader.loader += '?' + JSON.stringify({
        modifyVars: appPackage.theme
      });
    };

    return loader;
  })

  return config;
}
